from vibes import *
from myinterval import *

	
	
def drawtube(tmin,tmax,dt,color):
	t=tmin
	m=Interval(oo,oo)
	while t<tmax:
		x = Interval(t,t+dt)
		y=sqr(x)+2*x-exp(x)
		vibes.drawBox(x.lb, x.ub,y.lb, y.ub, color)
		t=t+dt	
		m=mini(m,y)
	print ("m = ",m)	
	return m

vibes.beginDrawing()
vibes.newFigure('Minimizer')
vibes.setFigureProperties({'x': 0, 'y': 0, 'width': 1600, 'height': 1000})
m=drawtube(-2,2,0.5,'[blue]')
m=drawtube(-2,2,0.05,'[yellow]')
m=drawtube(-2,2,0.005,'[red]')
m=drawtube(-2,2,0.0005,'[green]')
	
